#include "..\GEKXMath.h"

int NextSquare(int iValue)
{
	long Squared = 1;
	while(Squared < iValue) Squared <<= 1;
	if(Squared == iValue) return Squared;
	else return (Squared >> 1);
}

__declspec(naked) int __fastcall F2ID(float fValue)
{ 
	__asm
	{
		push      ebp
		mov       ebp,esp
		push      ecx
		push      ebx
		push      esi
		mov       eax,dword ptr [ebp+8]
		mov       ebx,eax
		sar       ebx,31
		mov       edx,eax
		and       edx,2147483647
		sar       edx,23
		add       edx,-127
		mov       ecx,edx
		sar       ecx,31
		not       ecx
		mov       dword ptr [ebp-4],ecx
		mov       ecx,dword ptr [ebp-4]
		and       ecx,edx
		push      ecx
		mov       ecx,31
		pop       esi
		sub       ecx,esi
		mov       esi,1
		shl       esi,cl
		dec       esi
		and       eax,8388607
		mov       ecx,31
		sub       ecx,edx
		mov       edx,eax
		or        edx,8388608
		shl       edx,8
		shr       edx,cl
		and       edx,dword ptr [ebp-4]
		xor       edx,ebx
		shl       eax,8
		test      eax,esi
		sete      al
		and       eax,1
		and       ebx,eax
		add       edx,ebx
		mov       eax,edx
		pop       esi
		pop       ebx
		pop       ecx
		pop       ebp
		ret       4
	};
}

__declspec(naked) int __fastcall F2IU(float fValue)
{ 
	__asm
	{
		push      ebp
		mov       ebp,esp
		push      ecx
		push      ebx
		push      esi
		mov       eax,dword ptr [ebp+8]
		xor       eax,-2147483648
		mov       edx,eax
		sar       edx,31
		mov       dword ptr [ebp-4],edx
		mov       edx,eax
		and       edx,2147483647
		sar       edx,23
		add       edx,-127
		mov       ebx,edx
		sar       ebx,31
		not       ebx
		mov       ecx,ebx
		and       ecx,edx
		push      ecx
		mov       ecx,31
		pop       esi
		sub       ecx,esi
		mov       esi,1
		shl       esi,cl
		dec       esi
		and       eax,8388607
		mov       ecx,31
		sub       ecx,edx
		mov       edx,eax
		or        edx,8388608
		shl       edx,8
		shr       edx,cl
		and       edx,ebx
		xor       edx,dword ptr [ebp-4]
		shl       eax,8
		test      eax,esi
		sete      al
		and       eax,1
		and       eax,dword ptr [ebp-4]
		and       ebx,eax
		add       edx,ebx
		neg       edx
		mov       eax,edx
		pop       esi
		pop       ebx
		pop       ecx
		pop       ebp
		ret       4
	};
}

__declspec(naked) float __fastcall ABS(float fValue)
{
	__asm 
	{
		fld		dword ptr[esp + 4] 
		fabs
		ret 4
	};
}

__declspec(naked) float __fastcall SIN(float fValue)
{
	__asm 
	{
		fld		dword ptr[esp + 4] 
		fsin
		ret 4
	};
}

__declspec(naked) float __fastcall COS(float fValue)
{
	__asm 
	{
		fld		dword ptr[esp + 4] 
		fcos
		ret 4
	};
}

float TAN(float fValue)
{
	return (SIN(fValue) / COS(fValue));
}

float SQRT(float fValue)
{
	return (fValue ? (fValue * ISQRT(fValue)) : 0.0f);
}

__declspec(naked) float __fastcall ISQRT(float fValue)
{
	__asm 
	{
		mov		eax, 0be6eb508h
		mov		dword ptr[esp-12],03fc00000h
		sub		eax, dword ptr[esp + 4]
		sub		dword ptr[esp+4], 800000h
		shr		eax, 1
		mov		dword ptr[esp -  8], eax

		fld		dword ptr[esp -  8]
		fmul	st, st
		fld		dword ptr[esp -  8]
		fxch	st(1)
		fmul	dword ptr[esp +  4]
		fld		dword ptr[esp - 12]
		fld		st(0)
		fsub	st,st(2)

		fld		st(1)
		fxch	st(1)
		fmul	st(3),st
		fmul	st(3),st
		fmulp	st(4),st
		fsub	st,st(2)

		fmul	st(2),st
		fmul	st(3),st
		fmulp	st(2),st
		fxch	st(1)
		fsubp	st(1),st

		fmulp	st(1), st
		ret 4
	}
}